package ru.ifmo.paraschenko;

import ru.ifmo.paraschenko.objects.IStringProcessor;

/**
 * Description.
 *
 * @author Dmitry Paraschenko
 */
public abstract class AbstractStringProcessorStrategy {
    private boolean check;
    private String name;

    public AbstractStringProcessorStrategy(boolean checkEquals, String name) {
        this.check = checkEquals;
        this.name = name;
    }

    public abstract IStringProcessor createInstance(String string) throws LargeInputSizeException;

    public abstract String getTime();
    
    public boolean isCheck() {
        return check;
    }

    public String getName() {
        return name;
    }

    public abstract double time();
}
