package ru.ifmo.paraschenko;

import ru.ifmo.paraschenko.objects.IStringProcessor;

/**
 * Description.
 *
 * @author Dmitry Paraschenko
 */
public abstract class BasicStringProcessorStrategy extends AbstractStringProcessorStrategy {
    protected long time0;
    protected long time1;
    
    public BasicStringProcessorStrategy(boolean checkEquals, String name) {
        super(checkEquals, name);
    }

    public IStringProcessor createInstance(String string) throws LargeInputSizeException {
        time0 = System.currentTimeMillis();
        IStringProcessor processor = createInstanceImpl(string);
        time1 = System.currentTimeMillis();
        return processor;
    }

    protected abstract IStringProcessor createInstanceImpl(String string) throws LargeInputSizeException;

    public String getTime() {
        return String.format("%.03f", (time1 - time0) / 1000.0);
    }

    public double time() {
        return (time1 - time0) / 1000.0;
    }
}
