package ru.ifmo.paraschenko.algorithms.tools;

import java.util.Arrays;

/**
 * Description.
 *
 * @author Dmitry Paraschenko
 */
public class SegmentTree {
    private static final int INF = 1000000000;

    private int nn;
    private int[] t;

    public SegmentTree(int n) {
        for (nn = 1; nn < n; nn *= 2) {
        }
        t = new int[2 * nn];
        Arrays.fill(t, INF);
    }

    public SegmentTree(int[] a) {
        this(a.length);
        System.arraycopy(a, 0, t, nn, a.length);
        for (int i = nn - 1; i >= 1; i--) {
            t[i] = Math.min(t[2 * i], t[2 * i + 1]);
        }
    }

    public void set(int pos, int value) {
        pos += nn;
        t[pos] = value;
        while (pos > 1) {
            pos /= 2;
            t[pos] = Math.min(t[2 * pos], t[2 * pos + 1]);
        }
    }

    public int getMin(int l, int r) {
        l += nn;
        r += nn;
        int result = INF;
        while (l <= r) {
            result = Math.min(result, Math.min(t[l], t[r]));
            l = (l + 1) / 2;
            r = (r - 1) / 2;
        }
        return result;
    }
}
