package ru.ifmo.paraschenko.objects;

import ru.ifmo.paraschenko.objects.IGraph;
import ru.ifmo.paraschenko.objects.graphs.AdjacencyListGraph;
import ru.ifmo.paraschenko.LargeInputSizeException;

/**
 * Description.
 *
 * @author Dmitry Paraschenko
 */
public class GraphFactoryBuilder {
    private static final GraphFactoryBuilder INSTANCE = new GraphFactoryBuilder();

    private static final IGraphFactory ADJANCENCY_LIST_GRAPH_FACTORY = new IGraphFactory() {
        public IGraph newInstance(int nodeCount, int edgeCount) throws LargeInputSizeException {
            return new AdjacencyListGraph(nodeCount, edgeCount);
        }
    };

    private GraphFactoryBuilder() {
    }

    public IGraphFactory getAdjacencyListGraphFactory() {
        return ADJANCENCY_LIST_GRAPH_FACTORY;
    }

    public static GraphFactoryBuilder getInstance() {
        return INSTANCE;
    }
}
