package ru.ifmo.paraschenko.objects;

import ru.ifmo.paraschenko.objects.automata.LinearSuffixAutomaton;
import ru.ifmo.paraschenko.LargeInputSizeException;

/**
 * Description.
 *
 * @author Dmitry Paraschenko
 */
public class SuffixAutomatonFactoryBuilder {
    private static final SuffixAutomatonFactoryBuilder INSTANCE = new SuffixAutomatonFactoryBuilder();

    private static final ISuffixAutomatonFactory LINEAR_SUFFIX_AUTOMATON_FACTORY = new ISuffixAutomatonFactory() {
        public ISuffixAutomaton newInstance(String string) throws LargeInputSizeException {
            return new LinearSuffixAutomaton(string);
        }
    };

    private SuffixAutomatonFactoryBuilder() {
    }

    public ISuffixAutomatonFactory getLinearSuffixAutomatonFactory() {
        return LINEAR_SUFFIX_AUTOMATON_FACTORY;
    }

    public static SuffixAutomatonFactoryBuilder getInstance() {
        return INSTANCE;
    }
}
