package ru.ifmo.paraschenko.objects.trees;

import ru.ifmo.paraschenko.LargeInputSizeException;

public final class MinimizedSuffixTree extends AbstractSuffixTree {
	public MinimizedSuffixTree(String string) throws LargeInputSizeException {
		super(string, 2 + 2 * string.length());
        if (string.length() > 10000) {
            throw new LargeInputSizeException();
        }
        int length = string.length();
		for (int i = 0; i <= length; i++) {
			addPath(i, length);
		}
	}

	private void addPath(int left, int right) {
        int node = 0;
        for (int i = left; i < right; ) {
            char ch = charAt(i);
            int edge = getEdge(node, ch);
            if (edge == -1) {
                edge = addEdge(node, createNode(), i, right);
            }
            int be = getBegin(edge);
            int en = getEnd(edge);
            for (int j = be; j < en; j++, i++) {
                if (i == right || charAt(j) != charAt(i)) {
                    splitEdge(edge, j - be);
//                    edge = getEdge(node, ch);
                    break;
                }
            }
            node = getTarget(edge);
        }
        setFinish(node, true);
    }
}
