package ru.ifmo.paraschenko.objects.trees;

import ru.ifmo.paraschenko.LargeInputSizeException;
import ru.ifmo.paraschenko.objects.trees.AbstractSuffixTree;

public final class SuffixTrie extends AbstractSuffixTree {
    public SuffixTrie(String string) throws LargeInputSizeException {
		super(string, 1 + string.length() * string.length());
        if (string.length() > 1000) {
            throw new LargeInputSizeException();
        }
        int length = string.length();
		for (int i = 0; i <= length; i++) {
			addPath(i, length);
		}
    }
	
	private void addPath(int left, int right) {
        int node = 0;
        for (int i = left; i < right; i++) {
            char ch = charAt(i);
            int edge = getEdge(node, ch);
            if (edge == -1) {
                edge = addEdge(node, createNode(), i, i + 1);
            }
            node = getTarget(edge);
        }
        setFinish(node, true);
	}
}
